
#ifndef MAIN_H
#define MAIN_H
#ifdef __cplusplus
extern "C" {
#endif

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
EWRAM_CODE void StateInit(); 
EWRAM_CODE void StateReset();
EWRAM_CODE void StateGame();
EWRAM_CODE void StateInput();
EWRAM_CODE void StateAnswer();

EWRAM_CODE void InitWS();
EWRAM_CODE void InitKey();
EWRAM_CODE void InitFont();
EWRAM_CODE void InitSprite();
EWRAM_CODE void InitIRQ();

//----
EWRAM_CODE void GoTakuInit();
EWRAM_CODE bool GoTakuLoadFile();
EWRAM_CODE bool GoTakuChkSignature();
EWRAM_CODE bool GoTakuChkStrLength();
EWRAM_CODE void GoTakuModStr(u8* str, u16 cnt);

EWRAM_CODE void GoTakuSetHeader();
EWRAM_CODE void GoTakuSetRand();
EWRAM_CODE void GoTakuSetQuestion();
EWRAM_CODE void GoTakuSetRandomAnswer();

EWRAM_CODE void GoTakuDrawFrame();
EWRAM_CODE void GoTakuDrawQuestion();
EWRAM_CODE void GoTakuDrawQuestionNo();

EWRAM_CODE void GoTakuDrawFont(u16 sx, u16 sy, u8* str);


//----
EWRAM_CODE void CursorInit();
EWRAM_CODE void CursorInput();
EWRAM_CODE void CursorDraw();
EWRAM_CODE bool CursorIsMove();
EWRAM_CODE void CursorMove();


#ifdef __cplusplus
}
#endif
#endif
